Arcane_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
local AC,AM,FB,AP,PoM,MI
local MGstartTime,MGduration,RPstartTime,AHRuneofPowerKnown,AHPoMKnown,AHcolorState

function Arcane_OnLoad(Frame)
    if select(2, UnitClass("player")) ~= "MAGE" then ArcaneFrame:Hide() return end

    Frame:RegisterForDrag("LeftButton")
    Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_TALENT_UPDATE")
	Frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

--Get spell infos:
    ACdebuff = GetSpellInfo(36032)
    AMbuff = GetSpellInfo(79683)
    RPbuff = GetSpellInfo(79683)
	--FB = GetSpellInfo(113092)
    AB = GetSpellInfo(30451)
	AM = GetSpellInfo(5143)
    AP = GetSpellInfo(12042)
    PoM = GetSpellInfo(12043)
    MI = GetSpellInfo(55342)
end

function Arcane_OnEvent(self, event, ...)
    if (event == "PLAYER_LOGIN") then
        if (ArcaneFrame:GetFrameLevel() == 0) then
	        ArcaneFrame:SetFrameLevel(1) -- fix when frame is at FrameLevel 0
	    end

        local ArcaneLoaded = GetSpecialization() == 1
		local a, b, c, d, AHRPSelected, e = GetTalentInfo(17)
		AHRuneofPowerKnown = AHRPSelected == true -- check if Rune of Power is a known talent
		local f, g, h, i, AHPoMSelected, j = GetTalentInfo(1)
		AHPoMKnown = AHPoMSelected == true --check if Presence of Mind is a known talent

		if ArcaneLoaded == true then
            ChatFrame1:AddMessage("|cff00ffffArcane Spec detected, Arcane Helper is loaded.|r")
			ArcaneTalent = true
		else
            ChatFrame1:AddMessage("|cff00ffffArcane spec not dectected, Arcane Helper is disabled.|r")
			ArcaneTalent = false
		end

--Set bars min and max:
        Healthbar:SetMinMaxValues(0,72)
        Manabar:SetMinMaxValues(0,72)
        ACbar:SetMinMaxValues(0,72)
        AMbar:SetMinMaxValues(0,72)
        RPbar:SetMinMaxValues(0,72)
        APbar:SetMinMaxValues(0,72)
        PoMbar:SetMinMaxValues(0,72)
        MIbar:SetMinMaxValues(0,72)

		--Initialize Mana Gem and Rune of Power calculation variables:
		MGduration = 120
		MGstartTime = 0

		RPstartTime = 0

        AHisFading = false
        AHcolorState = 0

		SetState()
	end

    if (event == "PLAYER_TALENT_UPDATE") then
        local ArcaneLoaded = GetSpecialization() == 1
		local a, b, c, d, AHRPSelected, e = GetTalentInfo(17)
		AHRuneofPowerKnown = AHRPSelected == true -- check if Rune of Power is a known talent
		local f, g, h, i, AHPoMSelected, j = GetTalentInfo(1)
		AHPoMKnown = AHPoMSelected == true --check if Presence of Mind is a known talent

		if ArcaneLoaded == true then
			if ArcaneTalent == false then
				ChatFrame1:AddMessage("|cff00ffffArcane Spec detected, Arcane Helper is loaded.|r")
				ArcaneTalent = true
			end
			ArcaneShow = true
		else
			if ArcaneTalent == true then
				ChatFrame1:AddMessage("|cff00ffffArcane spec not dectected, Arcane Helper is disabled.|r")
				ArcaneTalent = false
			end
			ArcaneShow = false
		end

		if ArcaneLoaded == true then
			if ArcaneTalent == false then
				ChatFrame1:AddMessage("|cff00ffffArcane Spec detected, Arcane Helper is loaded.|r")
				ArcaneTalent = true
			end
			ArcaneShow = true
		else
			if ArcaneTalent == true then
				ChatFrame1:AddMessage("|cff00ffffArcane spec not dectected, Arcane Helper is disabled.|r")
				ArcaneTalent = false
			end
			ArcaneShow = false
		end

		SetState()
	end

    if (event == "UNIT_SPELLCAST_SUCCEEDED") then
		local CastingUnit, SpellName = ...;
		if CastingUnit == "player" then
			if SpellName == "Replenish Mana" then
				MGstartTime = GetTime()
			end
			if SpellName == "Rune of Power" then
				RPstartTime = GetTime()
			end
		end
	end
end

SLASH_ARCANEHELPER1 = '/arcanehelper'
SLASH_ARCANEHELPER2 = '/ah'
SlashCmdList["ARCANEHELPER"] = function(msg)
	if msg == "lock" then
		ArcaneLock = true
	end

	if msg == "unlock" then
		ArcaneLock = false
	end

	if msg == "show" then
		ArcaneShow = true
	end

	if msg == "hide" then
		ArcaneShow = false
	end

	SetState()
end

--Utility function for frame functionality
function SetState()
	if (ArcaneLock == false)
		then ArcaneFrame:EnableMouse(true)
	elseif (ArcaneLock == true)
		then ArcaneFrame:EnableMouse(false)
	end

	if (ArcaneShow == true) and (not(ArcaneFrame:IsVisible())) then
		ArcaneFrame:Show()
	end

	if (ArcaneShow == false) and (ArcaneFrame:IsVisible()) then
		ArcaneFrame:Hide()
	end

	local AHBarCounter = 0

	if (ArcaneShowHealth == true) then
		HealthLabel:Show()
		HealthNumberLabel:Show()
		Healthbar:Show()
		HealthLabel:ClearAllPoints()
		HealthLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-5 - (11 * AHBarCounter)))
		AHBarCounter = AHBarCounter + 1
	else
		HealthLabel:Hide()
		HealthNumberLabel:Hide()
		Healthbar:Hide()
	end
	ManaLabel:ClearAllPoints()
    ManaLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-1*(5 + (11 * AHBarCounter))))
	AHBarCounter = AHBarCounter + 1
	ACLabel:ClearAllPoints()
    ACLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-1*(5 + (11 * AHBarCounter))))
	AHBarCounter = AHBarCounter + 1
	AMLabel:ClearAllPoints()
    AMLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-1*(5 + (11 * AHBarCounter))))
	AHBarCounter = AHBarCounter + 1
	if AHRuneofPowerKnown == true then
		RPLabel:Show()
		RPNumberLabel:Show()
		RPbar:Show()
		RPLabel:ClearAllPoints()
		RPLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-1*(5 + (11 * AHBarCounter))))
		AHBarCounter = AHBarCounter + 1
	else
		RPLabel:Hide()
		RPNumberLabel:Hide()
		RPbar:Hide()
	end
	APLabel:ClearAllPoints()
    APLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-5 - (11 * AHBarCounter)))
	AHBarCounter = AHBarCounter + 1
	MGLabel:ClearAllPoints()
    MGLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-5 - (11 * AHBarCounter)))
	AHBarCounter = AHBarCounter + 1
	if AHPoMKnown == true then
		PoMLabel:Show()
		PoMbar:Show()
		PoMLabel:ClearAllPoints()
		PoMLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-5 - (11 * AHBarCounter)))
		AHBarCounter = AHBarCounter + 1
	else
		PoMLabel:Hide()
		PoMbar:Hide()
	end
	MILabel:ClearAllPoints()
    MILabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",6,(-5 - (11 * AHBarCounter)))
	AHBarCounter = AHBarCounter + 1

	NextSpellLabel:ClearAllPoints()
    NextSpellLabel:SetPoint("TOPLEFT","ArcaneTextFrame","TOPLEFT",0,(-5 - (11 * AHBarCounter)))

	ArcaneFrame:SetHeight((11 * (AHBarCounter + 1)) + 15)
end

-- helper function for option panel setup
function ArcaneHelperOptions_OnLoad(panel)
	panel.name = "ArcaneHelper"
	InterfaceOptions_AddCategory(panel);
end

function ArcaneShowF()
	if ArcaneShowButton:GetChecked(true) then
		ArcaneShow = true
	else
		ArcaneShow = false
	end

	SetState()
end

function ArcaneLockF()
	if ArcaneLockButton:GetChecked(true) then
		ArcaneLock = true
	else
		ArcaneLock = false
	end

	SetState()
end

function ArcaneShowHealthF()
	if ArcaneHealthButton:GetChecked(true) then
		ArcaneShowHealth = true
	else
		ArcaneShowHealth = false
	end

	SetState()
end

-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------
function Arcane_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;

    if (self.TimeSinceLastUpdate > Arcane_UpdateInterval) then
		if (ArcaneTalent == true) then
			local time = GetTime()
			local InCombat = UnitAffectingCombat("player")

			--Health part
			if (ArcaneShowHealth == true) then
				local PlayerHealth = UnitHealth("player")
				local PlayerHealthMax = UnitHealthMax("player")
				local PlayerHealthPercent = PlayerHealth/PlayerHealthMax
				Healthbar:SetValue((72)*PlayerHealthPercent)
				HealthNumberLabel:SetText(floor((PlayerHealthPercent * 100) + 0.5))

				Healthbar:SetStatusBarColor(1.0, 0.0, 0.0, 1.0)
			end

			--Mana part
			local PlayerMana = UnitPower("player")
			local PlayerManaMax = UnitPowerMax("player")
			local PlayerManaPercent = PlayerMana/PlayerManaMax
			Manabar:SetValue((72)*PlayerManaPercent)
			ManaNumberLabel:SetText(floor((PlayerManaPercent * 100) + 0.5))
			Manabar:SetStatusBarColor(0.0, 0.0, 1.0, 1.0)

			--Arcane Blast part
			local ACcount
			local a,b,c,ACcountTemp,d,ACduration,ACexpireTime,e,f,g,ACspellId = UnitAura("player", ACdebuff, nil, "HARMFUL")
			local h,i,j,k,l,m,ABcastTime,n,o = GetSpellInfo(30451)
			local ACCurrentCastSpell, p, q, r, s, ACCurrentCastWillEnd, t, u, v = UnitCastingInfo("player")
			local ACCurrentChannelSpell, p, q, r, s, ACCurrentChannelWillEnd, t, u = UnitChannelInfo("player")
			local ACTooLate, ACExpireTimeDiff, ACCurrentCastWillEndDiff

			if (ACspellId == 36032) then
				ACcount = ACcountTemp
				ACExpireTimeDiff = (ACexpireTime - time)

				if ACExpireTimeDiff > 0 then
					if (ACCurrentCastSpell == nil) and (ACCurrentChannelSpell == nil) then
						ACTooLate = true
					else
						if (ACCurrentCastSpell == AB) or (ACCurrentChannelSpell == AM) then
							if (ACCurrentCastSpell == AB) then
								ACCurrentCastWillEndDiff = ((ACCurrentCastWillEnd / 1000) - time)
							end

							if (ACCurrentChannelSpell == AM) then
								ACCurrentCastWillEndDiff = ((ACCurrentChannelWillEnd / 1000) - time)
							end

							if ACCurrentCastWillEndDiff > ACExpireTimeDiff then
								ACTooLate = true
							else
								ACTooLate = false
							end
						else
							ACTooLate = true
						end
					end

					ACbar:Show()
					ACbar:SetValue((72)*(ACExpireTimeDiff/ACduration))

					ACNumberLabel:SetText(ACcount)

					if ACTooLate == false then
						ACbar:SetStatusBarColor(0.0, 1.0, 0.0, 1.0)
					else
						--Piecewise linear interpolation
						local ACbarColors = {{1.0, 0.0, 0.0}, {1.0, 0.0, 0.0}, {1.0, 1.0, 0.0}, {0.0, 1.0, 0.0}}
						local ACbarPoints = {0.0, ABcastTime / 1000, ABcastTime / 1000 + 2, ACduration}
						local lerpVal
						for i = 2, 4 do
							if (ACExpireTimeDiff < ACbarPoints[i]) or (i == 4) then
								lerpVal = (i - 1) + (ACExpireTimeDiff - ACbarPoints[i - 1]) / (ACbarPoints[i] - ACbarPoints[i - 1])
								break
							end
						end
						local floorVal = floor(lerpVal)
						local ceilVal = ceil(lerpVal)
						local fracVal = lerpVal - floorVal
						local lerpColor = {}
						for i = 1, 3 do
							lerpColor[i] = (1.0 - fracVal) * ACbarColors[floorVal][i] + fracVal * ACbarColors[ceilVal][i]
						end
						ACbar:SetStatusBarColor(lerpColor[1], lerpColor[2], lerpColor[3], 1.0)
					end
				else
					ACTooLate = true
				end
			else
				ACcount = 0
				ACbar:Hide()
				ACNumberLabel:SetText("")
			end

			--Arcane Missiles part
			local AMcount
			local a,b,c,AMcountTemp,d,AMduration,AMexpireTime,e,f,g,AMspellId = UnitAura("player", AMbuff, nil, "HELPFUL")
			local AMExpireTimeDiff, AMCurrentCastWillEndDiff
			if (AMspellId == 79683) then
				AMcount = AMcountTemp
				AMExpireTimeDiff = (AMexpireTime - time)

				if AMExpireTimeDiff > 0 then
					AMbar:Show()
					AMbar:SetValue((72)*(AMExpireTimeDiff/AMduration))

					AMNumberLabel:SetText(AMcount)

					AMbar:SetStatusBarColor(0.0, 1.0, 0.0, 1.0)
				else
					AMcount = 0
					AMbar:Hide()
					AMNumberLabel:SetText("")
				end
			else
				AMcount = 0
				AMbar:Hide()
				AMNumberLabel:SetText("")
			end

			--Rune of Power part
			if (AHRuneofPowerKnown == true) then
				if (60 - (time - RPstartTime)) > 0  then
					RPbar:Show()
					RPbar:SetValue((72)*((60 - (time - RPstartTime))/60))
					RPbar:SetStatusBarColor(0,0.5,0.8,1)
					RPLabel:SetText(format("|cffffffffRune|r"))
				else
					RPbar:Hide()
					if InCombat == 1 then
						RPLabel:SetText(format("|cffff0000Rune|r"))
					else
						RPLabel:SetText(format("|cffffffffRune|r"))
					end
				end
			end

			--Arcane Power part
			local APstartTime,APduration,APenabled = GetSpellCooldown(AP)

			if (APduration - (time - APstartTime)) > 0  then
				APbar:Show()
				APbar:SetValue((72)*((APduration - (time - APstartTime))/APduration))
				APbar:SetStatusBarColor(0,0.5,0.8,1)
			else APbar:Hide()
			end

			--Mana Gem part
			local w, MGdurationTemp, x = GetItemCooldown(36799)
			if MGdurationTemp > 0 then MGduration = MGdurationTemp end

			local MGcount = GetItemCount(36799, false, true)
			if MGcount == 0 then --Try the Brilliant mana gem, based on the glyph.
				MGcount = GetItemCount(81901, false, true)
			end
			if MGcount == 0 then
				if (MGduration - (time - MGstartTime)) > 0 then
					MGbar:SetStatusBarColor(1,1,0,1)
					MGNumberLabel:SetText(format("|cffffff00%.0f|r",MGcount))
					MGLabel:SetText(format("|cffffff00Mana Gem|r"))
				else
					MGNumberLabel:SetText(format("|cffff0000%.0f|r",MGcount))
					MGLabel:SetText(format("|cffff0000Mana Gem|r"))
				end
			else
				MGbar:SetStatusBarColor(0,0.5,0.8,1)
				MGNumberLabel:SetText(format("|cffffffff%.0f|r",MGcount))
				MGLabel:SetText(format("|cffffffffMana Gem|r"))
			end

			if (MGduration - (time - MGstartTime)) > 0  then
				MGbar:Show()
				MGbar:SetValue((72)*((MGduration - (time - MGstartTime))/MGduration))
			else MGbar:Hide()
			end

			--Presence of Mind part
			if (AHPoMKnown == true) then
				local PoMstartTime,PoMduration,PoMenabled = GetSpellCooldown(PoM)

				if (PoMduration - (time - PoMstartTime)) > 0  then
					PoMbar:Show()
					PoMbar:SetValue((72)*((PoMduration - (time - PoMstartTime))/PoMduration))
					PoMbar:SetStatusBarColor(0,0.5,0.8,1)
				else PoMbar:Hide()
				end
			end

			--Mirror Image part
			local MIstartTime,MIduration,MIenabled = GetSpellCooldown(MI)

			--The first term relates to the Mirror Image CD.  The second is for the global CD.
			if ((MIduration - (time - MIstartTime)) > 0) and (MIduration > 3)  then
				MIbar:Show()
				MIbar:SetValue((72)*((MIduration - (time - MIstartTime))/MIduration))
				MIbar:SetStatusBarColor(0,0.5,0.8,1)
			else MIbar:Hide()
			end

			--Next Spell Label and Clear Stacks Notification parts
			local ag,ah,ai,aj,ak,APBuffduration,APBuffexpireTime,al,am,an,APspellId = UnitAura("player", AP, nil, "HELPFUL")
			local AHArcanePowerActive = (APspellId == 12042)

			local AHisFading, AHfadePercent, AHfadeFrom, AHfadeTo
			local fadeColors = {{1.0, 1.0, 1.0}, {0.0, 0.7, 0.0}, {0.0, 0.0, 0.8}, {0.5, 0.8, 1.0}, {1.0, 0.0, 0.0}}

			local AHClearStacks = false
			local AHMissilesUpFullStacks = false
			local AHMissilesUpPartialStacks = false
			local AHStartBurning = false
			--This term can be added to the below If to make ArcaneHelper "look ahead" at the completion of the current spell for notifications.
			-- or ((ACcount == 5) and (ACTooLate == false))
			if (ACcount == 4) then
				--At 4 stacks.  Missiles if available, always.  Blast if over 70% mana.  Barrage when under that.
				--Also, if we're at better than 70% mana and AP is up, indicate that AP would be a good idea.
				if ((APduration - (time - APstartTime)) <= 0) and (PlayerManaPercent >= Arcane_Burnphase_Start_Mana_Threshold) then
					NextSpellLabel:SetText("|cff00ff00Arcane Power|r")
					AHStartBurning = true
				else
					if AMcount > 0 then
						NextSpellLabel:SetText("|cff00ffffArcane Missiles|r")
						AHMissilesUpFullStacks = true
					else
						NextSpellLabel:SetText("|cffff0000Arcane Barrage|r")
						AHClearStacks = true
					end
				end
			else
				--Not yet at 6 stacks.  Missles if at 2 stacks, Blast otherwise.
				if AMcount == 2 then
					NextSpellLabel:SetText("|cff00ffffArcane Missiles|r")
					AHMissilesUpPartialStacks = true
				else
					NextSpellLabel:SetText("|cffffffffArcane Blast|r")
				end
			end

			--Background coloration
			if (AHisFading == true) then
				AHfadePercent = AHfadePercent + 0.2 --Increase 0.2 to speed up the fading if desired
				if (AHfadePercent > 1.0) then AHfadePercent = 1.0 end
				local lerpColor = {}
				for i = 1, 3 do
					lerpColor[i] = (1.0 - AHfadePercent) * AHfadeFrom[i] + AHfadePercent * AHfadeTo[i]
				end
				ArcaneFrame:SetBackdropColor(lerpColor[1], lerpColor[2], lerpColor[3])
				if (AHfadePercent == 1.0) then AHisFading = false end
			elseif (AHStartBurning == true) then
				if (AHcolorState ~= 1) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = fadeColors[2]
				end
				ArcaneFrame:SetBackdropColor(fadeColors[AHcolorState + 1][1], fadeColors[AHcolorState + 1][2], fadeColors[AHcolorState + 1][3])
				AHcolorState = 1
			elseif (AHMissilesUpFullStacks == true) then
				if (AHcolorState ~= 3) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = fadeColors[4]
				end
				ArcaneFrame:SetBackdropColor(fadeColors[AHcolorState + 1][1], fadeColors[AHcolorState + 1][2], fadeColors[AHcolorState + 1][3])
				AHcolorState = 3
			elseif (AHMissilesUpPartialStacks == true) then
				if (AHcolorState ~= 3) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = fadeColors[4]
				end
				ArcaneFrame:SetBackdropColor(fadeColors[AHcolorState + 1][1], fadeColors[AHcolorState + 1][2], fadeColors[AHcolorState + 1][3])
				AHcolorState = 3
			elseif (AHClearStacks == true) then
				if (AHcolorState ~= 4) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = fadeColors[5]
				end
				ArcaneFrame:SetBackdropColor(fadeColors[AHcolorState + 1][1], fadeColors[AHcolorState + 1][2], fadeColors[AHcolorState + 1][3])
				AHcolorState = 4
			elseif (AHArcanePowerActive == true) then
				if (AHcolorState ~= 2) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = fadeColors[3]
				end
				ArcaneFrame:SetBackdropColor(fadeColors[AHcolorState + 1][1], fadeColors[AHcolorState + 1][2], fadeColors[AHcolorState + 1][3])
				AHcolorState = 2
			else 
				if (AHcolorState ~= 0) then
					AHisFading = true
					AHfadePercent = 0.0
					AHfadeFrom = fadeColors[AHcolorState + 1]
					AHfadeTo = {0.25, 0.25, 0.25}
					ArcaneFrame:SetBackdropColor(AHfadeFrom[1], AHfadeFrom[2], AHfadeFrom[3])
				else
					ArcaneFrame:SetBackdropColor(0.25, 0.25, 0.25)
				end
				AHcolorState = 0
			end
		end

		self.TimeSinceLastUpdate = 0
    end
end
